/*========================================================================
     "numlibArf" - regression to Arrhenius expression
     This is a part of "gpop" - Gaussian output post processor
             Copyright (c) 2002-2009 by A. Miyoshi, Univ. Tokyo
========================================================================*/

#ifndef _NUMLIBARF_H_
#define _NUMLIBARF_H_

#include "numlibBls.h"

/*========================================================================
     Rate coefficients regression to Arrhenius & modified Arrhenius
      expressions
========================================================================*/

struct kDatumT {
  double k, T;
};

class fitArrhenius : public basicLinLsSq {
 public:                                       // --- data members ---
  vector<kDatumT> kdat;
  double A, EaR, mA, mb, mEaR;
  double sdk, madk, maxadk, msdk, mmadk, mmaxadk;
 public:                                   // --- member functions ---
  fitArrhenius();
  void clear();
  int addDatumKT(double k, double T);
  int addDataKT(vector<kDatumT> &vkd);
  int solve();
};

#endif

