/*========================================================================
     Spline interpolation
             Copyright (c) 2009      by A. Miyoshi, Univ. Tokyo
========================================================================*/

#ifndef _SPLINE_H_
#define _SPLINE_H_

#include <iostream>
#include <fstream>
#include <sstream>
#include <iomanip>
#include <string>
#include <vector>
#include <set>
#include <map>
#include <cctype>
#include <cstring>
#include <cstdlib>
#include <cmath>
using namespace std;

#ifndef true
#define true (-1)
#endif
#ifndef false
#define false 0
#endif
#ifndef M_PI
#define	M_PI    3.14159265358979323846
#endif
#define NORM 0
#define ERRE 1

/*------------------------------------------------------------------------
     3rd-order natural spline interpolation
------------------------------------------------------------------------*/

class spl3coef : public vector<double> {
 public:                                         // --- data members ---
  double xmin, xmax;
 public:                                     // --- member functions ---
  spl3coef();
  spl3coef(double x0, double x1, double y);
  void init();
  void init(double x0, double x1, double y);
  void print(ostream &os);
  double eval(double x);
  double findYmin(double &xAtMin);
};                                                    // --- globals ---
ostream &operator<<(ostream &os, spl3coef &sc);

class spline3On {
 public:                                         // --- data members ---
  int numSegm;          // number of segments
  double xmin, xmax;
  vector<spl3coef> coef;
 public:                                     // --- member functions ---
  spline3On();
  void clear();
  int setFrom(vector<double> &xl, vector<double> &yl);
  void print(ostream &os);
  double eval(double x);
  double findYmin(double &xAtMin);
};                                                    // --- globals ---
ostream &operator<<(ostream &os, spline3On &s3);

#endif

