/*========================================================================
     This is a part of "gpop" - Gaussian output post processor
             Copyright (c) 2002-2009 by A. Miyoshi, Univ. Tokyo
========================================================================*/

#ifndef _VTST_H_
#define _VTST_H_

#include "gpoplibt.h"
#include "spline.h"

/*------------------------------------------------------------------------
     classes for variational transition state theory calculation
------------------------------------------------------------------------*/

class varTState {
 public:                             // --- data members ---
  int energySet;
  double coord, energy;
  string flname;
  vector<resultTST> calcRes;
  double dUts0, dHts298, dSts298;
 public:                         // --- member functions ---
  varTState();
  void clear();
};

class listVTS : public vector<varTState> {
 public:                             // --- data members ---
  int calEql;
  double dU0, dH298, dS298;
  vector<resultTST> vtstRes;
 public:                         // --- member functions ---
  listVTS();
  void clear();
};

/*------------------------------------------------------------------------
     local functions
------------------------------------------------------------------------*/

int readRxv(istream &is, reactionInfo *rx, listVTS *lvts);
int readPropRP(reactionInfo *rx);
int findMinRate(reactionInfo *rx, listVTS *lvts);
void writeCsv(ostream &os, listVTS *lvts);

#endif

